require 'net/http'
require 'json'
require 'openssl'

module Rufbit
    def self.send(title, data, state)
        path = "/v1/notify"
    
        body ={
            "API_KEY" => Rufbit.API_KEY,
            "title" => title,
            "data" => data,
            "state" => state
        }.to_json
    
        request = Net::HTTP::Post.new(path, initheader = {'Content-Type' =>'application/json'})
        request.body = body
        response = Net::HTTP.new(Rufbit.host, Rufbit.port)
        response.ssl_version = :TLSv1  
        response.use_ssl = true
        response.verify_mode = ::OpenSSL::SSL::VERIFY_NONE
        response.start {|http| @res = http.request(request) }
        
        #puts "Response #{@res.code} #{@res.message}: #{@res.body}"

        case @res.code
        when "400"
            raise InvalidRequestError.new(@res), "The request could not be processed properly, often due to missing or invalid parameters"
        when "401"
            raise AuthenticationError.new(@res), "The provided API-Key is invalid or missing"
        when "500"
            raise RufbitError.new(@res), "Something went wrong on our end. Please contact us if you believe this wasn't supposed to happen."
        end

        return JSON::parse @res.body
    end
end